%if 0%{?fedora} || 0%{?rhel} == 6
%global with_devel 1
%global with_bundled 0
%global with_debug 0
%global with_check 1
%global with_unit_test 1
%else
%global with_devel 0
%global with_bundled 0
%global with_debug 0
%global with_check 0
%global with_unit_test 0
%endif

%if 0%{?with_debug}
%global _dwz_low_mem_die_limit 0
%else
%global debug_package   %{nil}
%endif

%define copying() \
%if 0%{?fedora} >= 21 || 0%{?rhel} >= 7 \
%license %{*} \
%else \
%doc %{*} \
%endif

%global provider        github
%global provider_tld    com
%global project         Sirupsen
%global repo            logrus
# https://github.com/Sirupsen/logrus
%global provider_prefix %{provider}.%{provider_tld}/%{project}/%{repo}
%global import_path     %{provider_prefix}
%global commit          3cb248e9df77413d58a6330dde84236d04c197d5
%global shortcommit     %(c=%{commit}; echo ${c:0:7})

Name:       golang-%{provider}-%{project}-%{repo}
Version:    0.8.4
Release:    6%{?dist}
Summary:    Structured logger for Go
License:    MIT
URL:            https://%{provider_prefix}
Source0:        https://%{provider_prefix}/archive/%{commit}/%{repo}-%{shortcommit}.tar.gz

# If go_arches not defined fall through to implicit golang archs
%if 0%{?go_arches:1}
ExclusiveArch:  %{go_arches}
%else
ExclusiveArch:   %{ix86} x86_64 %{arm}
%endif
# If gccgo_arches does not fit or is not defined fall through to golang
%ifarch 0%{?gccgo_arches}
BuildRequires:   gcc-go >= %{gccgo_min_vers}
%else
BuildRequires:   golang
%endif

%description
%{summary}

%if 0%{?with_devel}
%package devel
Summary:       %{summary}
BuildArch:     noarch

%if 0%{?with_check}
BuildRequires: golang(github.com/bugsnag/bugsnag-go)
#BuildRequires: golang(github.com/getsentry/raven-go)
BuildRequires: golang(github.com/stretchr/testify/assert)
#BuildRequires: golang(github.com/stvp/go-udp-testing)
#BuildRequires: golang(github.com/tobi/airbrake-go)
%endif

Requires:      golang(github.com/bugsnag/bugsnag-go)
#Requires:      golang(github.com/getsentry/raven-go)
Requires:      golang(github.com/stretchr/testify/assert)
#Requires:      golang(github.com/stvp/go-udp-testing)
#Requires:      golang(github.com/tobi/airbrake-go)

Provides:      golang(%{import_path}) = %{version}-%{release}
Provides:      golang(%{import_path}/formatters/logstash) = %{version}-%{release}
#Provides:      golang(%{import_path}/hooks/airbrake) = %{version}-%{release}
Provides:      golang(%{import_path}/hooks/bugsnag) = %{version}-%{release}
#Provides:      golang(%{import_path}/hooks/papertrail) = %{version}-%{release}
#Provides:      golang(%{import_path}/hooks/sentry) = %{version}-%{release}
#Provides:      golang(%{import_path}/hooks/syslog) = %{version}-%{release}

%description devel
%{summary}

This package contains library source intended for
building other packages which use import path with
%{import_path} prefix.
%endif

%if 0%{?with_unit_test}
%package unit-test
Summary:         Unit tests for %{name} package
# If go_arches not defined fall through to implicit golang archs
%if 0%{?go_arches:1}
ExclusiveArch:  %{go_arches}
%else
ExclusiveArch:   %{ix86} x86_64 %{arm}
%endif
# If gccgo_arches does not fit or is not defined fall through to golang
%ifarch 0%{?gccgo_arches}
BuildRequires:   gcc-go >= %{gccgo_min_vers}
%else
BuildRequires:   golang
%endif

%if 0%{?with_check}
#Here comes all BuildRequires: PACKAGE the unit tests
#in %%check section need for running
%endif

# test subpackage tests code from devel subpackage
Requires:        %{name}-devel = %{version}-%{release}

%description unit-test
%{summary}

This package contains unit tests for project
providing packages with %{import_path} prefix.
%endif

%prep
%setup -q -n %{repo}-%{commit}

%build

%install
# source codes for building projects
%if 0%{?with_devel}
install -d -p %{buildroot}/%{gopath}/src/%{import_path}/
# find all *.go but no *_test.go files and generate devel.file-list
for file in $(find . -iname "*.go" \! -iname "*_test.go") ; do
    install -d -p %{buildroot}/%{gopath}/src/%{import_path}/$(dirname $file)
    cp -pav $file %{buildroot}/%{gopath}/src/%{import_path}/$file
    echo "%%{gopath}/src/%%{import_path}/$file" >> devel.file-list
done
%endif

# testing files for this project
%if 0%{?with_unit_test}
install -d -p %{buildroot}/%{gopath}/src/%{import_path}/
# find all *_test.go files and generate unit-test.file-list
for file in $(find . -iname "*_test.go"); do
    install -d -p %{buildroot}/%{gopath}/src/%{import_path}/$(dirname $file)
    cp -pav $file %{buildroot}/%{gopath}/src/%{import_path}/$file
    echo "%%{gopath}/src/%%{import_path}/$file" >> unit-test.file-list
done
%endif

%check
%if 0%{?with_check} && 0%{?with_unit_test} && 0%{?with_devel}
%ifarch 0%{?gccgo_arches}
function gotest { %{gcc_go_test} "$@"; }
%else
%if 0%{?golang_test:1}
function gotest { %{golang_test} "$@"; }
%else
function gotest { go test "$@"; }
%endif
%endif

export GOPATH=%{buildroot}/%{gopath}:%{gopath}
gotest %{import_path}
gotest %{import_path}/formatters/logstash
#gotest %{import_path}/hooks/airbrake
gotest %{import_path}/hooks/bugsnag
#gotest %{import_path}/hooks/papertrail
#gotest %{import_path}/hooks/sentry
#gotest %{import_path}/hooks/syslog
%endif

%if 0%{?with_devel}
%files devel -f devel.file-list
%copying LICENSE
%doc README.md CHANGELOG.md
%dir %{gopath}/src/%{provider}.%{provider_tld}/%{project}
%dir %{gopath}/src/%{import_path}
%endif

%if 0%{?with_unit_test}
%files unit-test -f unit-test.file-list
%copying LICENSE
%doc README.md CHANGELOG.md
%endif

%changelog
* Thu Jul 21 2016 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.8.4-6
- https://fedoraproject.org/wiki/Changes/golang1.7

* Sun Mar 06 2016 jchaloup <jchaloup@redhat.com> - 0.8.4-5
- Add hooks/bugsnag to provided packages
  related: #1246085

* Mon Feb 22 2016 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.8.4-4
- https://fedoraproject.org/wiki/Changes/golang1.6

* Wed Feb 03 2016 Fedora Release Engineering <releng@fedoraproject.org> - 0.8.4-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Thu Jul 23 2015 Fridolin Pokorny <fpokorny@redhat.com> - 0.8.4-2
- Update spec file to spec-2.0
  related: #1246085

* Thu Jul 23 2015 Fridolin Pokorny <fpokorny@redhat.com> - 0.8.4-1
- Bump to upstream 3cb248e9df77413d58a6330dde84236d04c197d5
  resolves: #1246085

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.6.4-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Thu Jan 29 2015 jchaloup <jchaloup@redhat.com> - 0.6.4-1
- Bump to upstream 51fe59aca108dc5680109e7b2051cbdcfa5a253c
  related: #1158670

* Fri Jan 02 2015 jchaloup <jchaloup@redhat.com> - 0.6.2-1
- Update to 0.6.2
  related: #1158670

* Sun Nov 30 2014 Lokesh Mandvekar <lsm5@fedoraproject.org> - 0.6.0-1
- Update to 0.6.0

* Thu Oct 30 2014 Lokesh Mandvekar <lsm5@fedoraproject.org> - 0.5.1-2
- Resolves: rhbz#1158670 - initial package bug
- courtesy Jan Chaloupka <jchaloup@redhat.com>
- update dependencies
- add check

* Wed Oct 29 2014 Lokesh Mandvekar <lsm5@fedoraproject.org> - 0.5.1-1
- Initial package
